#include <sys/types.h>
#include "brltk.h"
#include <stdio.h>
#include <string.h>
#include <brltty/api.h>
#include <unistd.h>
#include <stdlib.h>

#define WIDTH 80
#define HEIGHT 8
char bools[HEIGHT][WIDTH];

void etape(char *bools, int width, int height) {
  char tmp[height][width];
  int i,j;
  int nb;
  memcpy(tmp,bools,width*height);
  for (j=0;j<height;j++) {
    for (i=0;i<width;i++) {
      nb =
	tmp[(j+height-1)%height][(i+width-1)%width] +
	tmp[(j+height-1)%height][ i               ] +
	tmp[(j+height-1)%height][(i      +1)%width] +
	tmp[ j                 ][(i+width-1)%width] +
	tmp[ j                 ][(i      +1)%width] +
	tmp[(j       +1)%height][(i+width-1)%width] +
	tmp[(j       +1)%height][ i               ] +
	tmp[(j       +1)%height][(i      +1)%width] +
	0;
      if (nb==3) bools[j*width+i] = 1;
      if (nb<2 || nb>=4) bools[j*width+i] = 0;
    }
  }
}

int main(void) {
  int i,j;
  bools[0][1] = 1;
  bools[1][2] = 1;
  bools[2][0] = 1;
  bools[2][1] = 1;
  bools[2][2] = 1;
  if (brlapi_initializeConnection(NULL,NULL)<0) {
    brlapi_perror("brlapi_initializeConnection");
    exit(1);
  }
  if (brlapi_getTty(-1,NULL) == -1) {
    brlapi_perror("brlapi_getTty");
    exit(1);
  }
  brlapi_ignoreKeyRange(0,BRL_KEYCODE_MAX);
  while(1) {
    brltk_showBool((char *) bools,WIDTH,HEIGHT);
    for (j=0;j<HEIGHT;j++) {
      for (i=0;i<WIDTH;i++)
	putchar(bools[j][i]?'#':' ');
      putchar('\n');
    }
    etape((char*) bools, WIDTH, HEIGHT);
    usleep(300000);
    for (i=0;i<WIDTH;i++)
      putchar('-');
    putchar('\n');
  }
  brlapi_leaveTty();
  brlapi_closeConnection();
}
